$fn = 50;
H = 60;
W = 110;
L = 110;
D = 5;
t = 1.5; // walls
lid_t = 5;
corner_offs = 22;
offs = 15;
eps = 0.05;

module rounded_rectangle(w, l, h) {
    hull() {
        translate([-w/2+5/2, -l/2+5/2, 0])
            cylinder(h = h, d = 5, center = true);
        translate([-w/2+5/2, l/2-5/2, 0])
            cylinder(h = h, d = 5, center = true);
        translate([w/2-5/2, -l/2+5/2, 0])
            cylinder(h = h, d = 5, center = true);
        translate([w/2-5/2, l/2-5/2, 0])
            cylinder(h = h, d = 5, center = true);
    }
}

// enclusure
/* */
color("#00eecc") {
    union() {
        difference() {
            union() {
                difference() {
                    rounded_rectangle(W, L, H);
                    translate([0, 0, t])
                        rounded_rectangle(W-2*t, L-2*t, H);
                }
                
                translate([(W-corner_offs-eps)/2, (L-corner_offs-eps)/2, -lid_t/2])
                    difference() {
                        rounded_rectangle(corner_offs, corner_offs, H-lid_t-eps);
                        cylinder(d = 4, h = H*2, center = true);
                    }
                translate([-(W-corner_offs-eps)/2, (L-corner_offs-eps)/2, -lid_t/2])
                    difference() {
                        rounded_rectangle(corner_offs, corner_offs, H-lid_t-eps);
                        cylinder(d = 4, h = H*2, center = true);
                    }

                translate([(W-corner_offs-eps)/2, -(L-corner_offs-eps)/2, -lid_t/2])
                    difference() {
                        rounded_rectangle(corner_offs, corner_offs, H-lid_t-eps);
                        cylinder(d = 4, h = H*2, center = true);
                    }
                translate([-(W-corner_offs-eps)/2, -(L-corner_offs-eps)/2, -lid_t/2])
                    difference() {
                        rounded_rectangle(corner_offs, corner_offs, H-lid_t-eps);
                        cylinder(d = 4, h = H*2, center = true);
                    }
        	}

			// hole for the capacitor
			translate([0, -L/2, -H/2+24+t]) rotate([90, 0, 0])
				cylinder(d = 10, h = L, center = true);

			// holes for M6 screws
			translate([W/2-30, L/2, 0]) rotate([90, 0, 0])
				cylinder(d = 6.5, h = L, center = true);
			translate([-W/2+30, L/2, 0]) rotate([90, 0, 0])
				cylinder(d = 6.5, h = L, center = true);

        }
    }
}
/* */

// loop mount
/* */
difference() {
	translate([0, L/2+30/2, 0])
		rounded_rectangle(W, 30, H);

	// holes for M6 screws
	translate([W/2-30, L/2, 0]) rotate([90, 0, 0])
		cylinder(d = 6.5, h = L, center = true);
	translate([-W/2+30, L/2, 0]) rotate([90, 0, 0])
		cylinder(d = 6.5, h = L, center = true);

	translate([0, (800+16)/2 + L/2 + t, 0])
		cylinder(d = 800+16, h = 16, center = true, $fn = 100);

	translate([0, (800+16)/2 + L/2 + 16 + t, 0])
		cylinder(d = 800+16, h = L*2, center = true, $fn = 100);


}
/* */

// lid
/* */
color("#0055ff", alpha = 0.5) {
    difference() {
        translate([0, 0, H/2-lid_t/2])
            rounded_rectangle(W-2*t-eps,L-2*t-eps, lid_t);
        
        translate([(W-corner_offs-eps)/2, (L-corner_offs-eps)/2, H/2-lid_t/4-eps]) {
                cylinder(d = 3.5, h = H*2, center = true);
                cylinder(h = lid_t/2, d = 6, center = true);
        }

        translate([-(W-corner_offs-eps)/2, (L-corner_offs-eps)/2, H/2-lid_t/4-eps]) {
                cylinder(d = 3.5, h = H*2, center = true);
                cylinder(h = lid_t, d = 6, center = true);
        }

        translate([(W-corner_offs-eps)/2, -(L-corner_offs-eps)/2, H/2-lid_t/4-eps]) {
                cylinder(d = 3.5, h = H*2, center = true);
                cylinder(h = lid_t, d = 6, center = true);
        }

        translate([-(W-corner_offs-eps)/2, -(L-corner_offs-eps)/2, H/2-lid_t/4-eps]) {
                cylinder(d = 3.5, h = H*2, center = true);
                cylinder(h = lid_t, d = 6, center = true);
        }

		// mounting holes
		translate([0, L/2 - 20, 0])
			cylinder(d = 3.5, h = H*2, center = true);
		translate([0, -L/2 + 20, 0])
			cylinder(d = 3.5, h = H*2, center = true);
    }
}
/* */
